
--[[
GSLIB
Gif Loading/Playing Library
Created for loading/playing gifs with ease
This library was created by Bruce Berrios
]]--


print("GSLIB LOADED...")

local gs = {}
gs.__index = gs

local i = ""

function gs:Init(x)
  i = x
  print(x.." Initialized!")
end

setmetatable(gs, {
    _call = function(cls,...)
      return cls.new(...)
    end,
})

function gs.NewGif(init,loop)
  local self = setmetatable({},gs)
  local frames = love.filesystem.getDirectoryItems(init)
  print("Loading Frames From..."..init)
  self.image = {}
  self.index = 1
  self.timer = 0
  self.frames = 0
  self.loop = loop
  for i = 1, #frames do
    print("Frame: "..i.." "..frames[i])
    self.image[i] = love.graphics.newImage(init..frames[i])
    self.frames = i
  end
  return self
end

function gs.UpdateGif(self,dt,speed)
  self.timer = self.timer + dt
  if self.timer >= speed then
    if self.loop then
      if self.index >= self.frames then
        self.index = 1
      elseif self.index <= self.frames then
        self.index = self.index + 1
      end
    elseif not self.loop then
      if self.index >= self.frames then
        self.index = self.frames
      elseif self.index <= self.frames then
        self.index = self.index + 1
      end
    end
    self.timer = 0
  end
end

function gs.DrawGif(self,x,y,rt,sx,sy)
  love.graphics.draw(self.image[self.index],x,y,rt,sx,sy)
end

return gs